"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setEmissiveStrength = void 0;
var extensions_1 = require("@gltf-transform/extensions");
var constants_1 = require("../constants");
function setEmissiveStrength(doc, strength) {
    if (strength === void 0) { strength = constants_1.EMISSIVE_STRENGTH; }
    var emissiveStrengthExtension = doc.createExtension(extensions_1.MaterialsEmissiveStrength);
    var emissiveStrength = emissiveStrengthExtension.createEmissiveStrength().setEmissiveStrength(strength);
    doc.createExtension(extensions_1.TextureWebP).setRequired(true);
    doc.getRoot().listMaterials().forEach(function (material) {
        material.setExtension('KHR_materials_emissive_strength', emissiveStrength);
    });
}
exports.setEmissiveStrength = setEmissiveStrength;
