"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = void 0;
var core_1 = require("@gltf-transform/core");
var meshoptimizer_1 = require("meshoptimizer");
var functions_1 = require("@gltf-transform/functions");
var constants_1 = require("../constants");
function transform(doc, _a) {
    var _b, _c, _d, _e, _f;
    var _g = _a === void 0 ? {
        draco: { method: constants_1.DRACO_METHOD },
        weld: { tolerance: constants_1.WELD_TOLERANCE },
        simplify: {
            enabled: constants_1.SIMPLIFY,
            ratio: constants_1.SIMPLIFY_RATIO,
            error: constants_1.SIMPLIFY_ERROR
        },
        texture: {
            resize: {
                resolution: constants_1.TEXTURE_RESIZE_RESOLUTION,
                filter: constants_1.TEXTURE_RESIZE_FILTER
            }
        }
    } : _a, _draco = _g.draco, _weld = _g.weld, _simplify = _g.simplify, _texture = _g.texture;
    return __awaiter(this, void 0, void 0, function () {
        var functions;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0: return [4 /*yield*/, meshoptimizer_1.MeshoptEncoder.ready];
                case 1:
                    _h.sent();
                    functions = new Set([
                        (0, functions_1.resample)(),
                        (0, functions_1.draco)({ method: (_b = _draco === null || _draco === void 0 ? void 0 : _draco.method) !== null && _b !== void 0 ? _b : constants_1.DRACO_METHOD }),
                        (0, functions_1.reorder)({ encoder: meshoptimizer_1.MeshoptEncoder }),
                        (0, functions_1.prune)(),
                        (0, functions_1.dedup)({ propertyTypes: [core_1.PropertyType.MESH] })
                    ]);
                    if ((_c = _simplify === null || _simplify === void 0 ? void 0 : _simplify.enabled) !== null && _c !== void 0 ? _c : constants_1.SIMPLIFY) {
                        functions
                            .add((0, functions_1.weld)({ tolerance: (_d = _weld === null || _weld === void 0 ? void 0 : _weld.tolerance) !== null && _d !== void 0 ? _d : constants_1.WELD_TOLERANCE }))
                            .add((0, functions_1.simplify)({
                            simplifier: meshoptimizer_1.MeshoptSimplifier,
                            ratio: (_e = _simplify === null || _simplify === void 0 ? void 0 : _simplify.ratio) !== null && _e !== void 0 ? _e : constants_1.SIMPLIFY_RATIO,
                            error: (_f = _simplify === null || _simplify === void 0 ? void 0 : _simplify.error) !== null && _f !== void 0 ? _f : constants_1.SIMPLIFY_ERROR
                        }));
                    }
                    return [4 /*yield*/, doc.transform.apply(doc, Array.from(functions))];
                case 2: return [2 /*return*/, _h.sent()];
            }
        });
    });
}
exports.transform = transform;
